/* clock.c
 * eine Uhr für den AVR 
 */
 
#include "main.h"

struct time_st zeit;
int tickcount = (SYSCLK/256 - 1);

const char days_in_month[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
const char monat[12][4] = 
{ "Jan\0",
  "Feb\0",
  "Mar\0",
  "Apr\0",
  "Mai\0",
  "Jun\0",
  "Jul\0",
  "Aug\0",
  "Sep\0",
  "Okt\0",
  "Nov\0",
  "Dez\0"
};

void Timer1_Init()
{
	TCCR1A = 0;
	TCCR1B = 0x0C;	// clk/256
	OCR1A = tickcount;
	TIMSK |= (1<<OCIE1A);
}

ISR(SIG_OUTPUT_COMPARE1A)
{
	zeit.sec++;
	zeit.sec_cnt++;
	if(zeit.sec >= 60)
	{
		zeit.sec = 0;
		zeit.min++;
		if(zeit.min >= 60)
		{
			zeit.min = 0;
			zeit.hour++;
			zeit.hour_cnt++;
			if(zeit.hour >= 24)
			{
				zeit.hour = 0;
				zeit.day++;
				if(zeit.day > days_in_month[zeit.month])
				{
					zeit.day = 1;
					zeit.month++;
					if(zeit.month > 12)
						zeit.month = 1;
				}
			}
		}
	}
}
