#include "main.h"

struct eeprom_giess *gpEEPROM = (struct eeprom_giess*)0;
#define EEPROM_ADDR_TICKCOUNT	(uint16_t*)(sizeof(struct eeprom_giess)*6)

struct time_st zuletzt_gegossen[6];

#define AUTOMATIK_OFF	0xFF
#define AUTOMATIK_TIME	'T'
#define AUTOMATIK_MEAS	'M'
#define AUTOMATIK_WARN	'W'

void get_flower_name(unsigned char index, char* name);
void print_time(struct time_st *pTime);

/*
void blink()
{	
	while(1)
	{
		PORTB = 0;
		PORTD = 0x08;
		Delay_ms(500);	
		PORTD = 0x10;
		Delay_ms(600);	
		PORTD = 0x20;
		Delay_ms(700);	
		PORTD = 0x40;
		Delay_ms(800);	
		PORTD = 0x80;
		Delay_ms(900);	
		PORTB = 0x01;
		PORTD = 0;
		Delay_ms(1000);	
	}
}
*/
void switch_pump(unsigned char index, char on_off)
{
//	char name[16];
	if(index == 0)
	{
		if(on_off)	PORTD |= 0x08;
		else		PORTD &= ~0x08;
	}
	if(index == 1)
	{
			if(on_off)	PORTD |= 0x10;
			else		PORTD &= ~0x10;
	}
	if(index == 2)
	{
			if(on_off)	PORTD |= 0x20;
			else		PORTD &= ~0x20;
	}
	if(index == 3)
	{
			if(on_off)	PORTD |= 0x40;
			else		PORTD &= ~0x40;
	}
	if(index == 4)
	{
			if(on_off)	PORTD |= 0x80;
			else		PORTD &= ~0x80;
	}
	if(index == 5)
	{
			if(on_off)	PORTB |= 0x01;
			else		PORTB &= ~0x01;
	}
	
//	get_flower_name(index, name);
	if(on_off)
	{
//		printf("* giesse %s !\r\n", name);
		memcpy(&zuletzt_gegossen[index], &zeit, sizeof(struct time_st));
	}
//	else
//		printf("* %s fertig gegossen. *\r\n", name);
}

char pump_status(unsigned char index)
{
	if(index == 0)
	{
			if(PIND & 0x08) return 1;
			else return 0;
	}	
	if(index == 1)
	{
			if(PIND & 0x10) return 1;
			else return 0;
	}		
	if(index == 2)
	{
			if(PIND & 0x20) return 1;
			else return 0;
	}		
	if(index == 3)
	{
			if(PIND & 0x40) return 1;
			else return 0;
	}		
	if(index == 4)
	{
			if(PIND & 0x80) return 1;
			else return 0;
	}		
	if(index == 5)
	{
			if(PINB & 0x01) return 1;
			else return 0;
	}
	return -1;
}

void get_flower_name(unsigned char index, char* name)
{
	eeprom_read_block(name, gpEEPROM[index].name, 16);
	name[15] = 0;
	if(name[0] < 0x20)
	{
		strcpy(name, "Blume  ");
		name[6] = index+'1';
	}
}
	
void print_menu()
{
	unsigned char i;
	char name[16];
	uart_puts_P(PSTR("\r\n\nGiess-o-mat Hauptmenue\r\n"));
	for(i=1; i<=6; i++)
	{
		get_flower_name(i-1, name);
		printf(" %d - %s\r\n", i, name); 
	}		
	uart_puts_P(PSTR(" a - alle ADCs anzeigen\r\n"));
	uart_puts_P(PSTR(" k - aktuelle Konfiguration anzeigen\r\n"));
	uart_puts_P(PSTR(" u - Uhr stellen\r\n\n"));
}
 	
void print_adcs()
{
	char i;
	unsigned char sec = 0;
	
	while(!uart_is_rx())
	{
		if(zeit.sec != sec)
		{
			autogiess();
			uart_puts_P(PSTR("\r\nADCs:"));
			for(i=0; i<6; i++)
			{
				printf(" %4d", read_adc(i));
			}
			sec = zeit.sec;
		}
	}
}

void print_config()
{
	unsigned char i;
	uint16_t feuchte;
	struct eeprom_giess flower;
	
	uart_puts_P(PSTR("\r\nBlume            Auto  Ein Mess  Aus Pumpe zuletzt gegossen"));
	for(i=0; i<6; i++)
	{
		eeprom_read_block(&flower, &gpEEPROM[i], sizeof(struct eeprom_giess));
		get_flower_name(i, flower.name);
		feuchte = read_adc(i);
		printf("\r\n%-16s ", flower.name);
		
		if(flower.automatik == AUTOMATIK_TIME)
		{
			uart_puts_P(PSTR("TIMER"));
			printf(" %02dm%02ds%3dd%02dh ", flower.seconds_on/60, flower.seconds_on%60, 
				flower.hours_off/24, flower.hours_off%24);
		}
		else if(flower.automatik == AUTOMATIK_MEAS)
		{
			uart_puts_P(PSTR("MESS "));
			printf("%4d %4d %4d ", flower.pump_on, feuchte, flower.pump_off);	
		}				
		else if(flower.automatik == AUTOMATIK_WARN)
		{
			uart_puts_P(PSTR("WARN "));
			printf("%4d %4d      ", flower.pump_on, feuchte);	
		}	
		else	
		{
			uart_puts_P(PSTR("AUS  "));
			printf("     %4d      ", feuchte);	
		}
		if(pump_status(i))
			uart_puts_P(PSTR(" AN   "));
		else
			uart_puts_P(PSTR(" AUS  "));
		
		print_time(&zuletzt_gegossen[i]);	
	}	
}

void print_time(struct time_st *pTime)
{
	printf("%02d.%s. %02d:%02d:%02d", 
			pTime->day, 
			monat[pTime->month-1],
			pTime->hour, 
			pTime->min, 
			pTime->sec);
}	

void set_time()
{
	int newtick;
	uart_puts_P(PSTR("\r\nMonat (1-12) ? "));
	zeit.month = uart_read_nr();	
	uart_puts_P(PSTR("\r\nTag ? "));
	zeit.day = uart_read_nr();
	uart_puts_P(PSTR("\r\nStunde ? "));
	zeit.hour = uart_read_nr();
	uart_puts_P(PSTR("\r\nMinute ? "));
	zeit.min = uart_read_nr();
	zeit.sec = 0;
	uart_puts_P(PSTR("\r\nSekundenlaenge Feintuning:\r\n"));
	printf("aktuell=%d. neuer Wert (ENTER=keine Aenderung) ?", tickcount);
	newtick = uart_read_nr();
	if(newtick > 0)
	{
		tickcount = newtick;
		eeprom_write_word(EEPROM_ADDR_TICKCOUNT, newtick);
		Timer1_Init(); 
	}
}
	
void print_flower_setup(unsigned char index, struct eeprom_giess* pGiess)
{
	printf("\r\n\n** %s **\r\n", pGiess->name); 
	uart_puts_P(PSTR(" n - Blumennamen aendern\r\n"));
	uart_puts_P(PSTR(" i - Pumpe ein\r\n"));
	uart_puts_P(PSTR(" o - Pumpe aus\r\n"));
	uart_puts_P(PSTR(" m - Min/Max Werte zuruecksetzen\r\n"));
	uart_puts_P(PSTR(" a - Automatik Modus\r\n"));
	uart_puts_P(PSTR(" z - Hauptmenue\r\n\n"));
		
	if(pGiess->automatik == AUTOMATIK_TIME)
	{	
		uart_puts_P(PSTR("Zeitsteuerung ein\r\n"));
		printf(" t - Intervall: %d Tage, %d Std.\r\n", 
			pGiess->hours_off/24, pGiess->hours_off%24);
		printf("     Giesszeit: %02d:%02d min\r\n",
			pGiess->seconds_on/60, pGiess->seconds_on%60);
	}		
	else if(pGiess->automatik == AUTOMATIK_MEAS)
	{
		uart_puts_P(PSTR("Feuchtigkeitsmessung\r\n"));		
		printf(" x - Ausschaltpunkt: %d\r\n", pGiess->pump_off);
		printf(" y - Einschaltpunkt: %d\r\n", pGiess->pump_on);
	}	
	
	else if(pGiess->automatik == AUTOMATIK_WARN)
	{
		uart_puts_P(PSTR("Warnblinker\r\n"));		
		printf(" y - Alarmwert: %d\r\n", pGiess->pump_on);
	}		
			
	else // AUTOMATIK_OFF:
	{
		uart_puts_P(PSTR("Automatik ist aus\r\n"));
	}
	uart_puts_P(PSTR("\r\nMin  Mess Max\r\n"));
}
		
char flower_setup(unsigned char index)
{
	unsigned char i;
	uint16_t min = 1023;
	uint16_t max = 0;
	uint16_t act;
	char uart_in, z;
	struct eeprom_giess flower;
	eeprom_read_block(&flower, &gpEEPROM[index], sizeof(struct eeprom_giess));
	get_flower_name(index, flower.name);
	print_flower_setup(index, &flower);
	char save;
	
	while(1)
	{
		act = read_adc(index);	
		if(act > max)
			max = act;
		if(act < min)
			min = act;
		
		printf("\r%4d %4d %4d  ", min, act, max);
		
		if(uart_is_rx())
		{
			uart_in = uart_getchar();	
			save = 0;	
			switch(uart_in)
			{
				case 'm':
					min = 1023;
					max = 0;
					break;
					
				case 'i':
					switch_pump(index, 1);
					break;
					
				case 'o':
					switch_pump(index, 0);
					break;	
					
				case 'x':
					printf("Ausschaltpunkt ? ");
					flower.pump_off = uart_read_nr();
					save = 1;
					break;
					
				case 'y':
					printf("Einschaltpunkt ? ");
					flower.pump_on = uart_read_nr();
					save = 1;
					break;
					
				case 'a':
					if(flower.automatik == 'M')
						flower.automatik = AUTOMATIK_TIME;
					else if(flower.automatik == 'T')
						flower.automatik = AUTOMATIK_WARN;
					else if(flower.automatik == 'W')
						flower.automatik = AUTOMATIK_OFF;
					else
						flower.automatik = AUTOMATIK_MEAS;
					save = 1;
					break;	
					
				case 'n':
					uart_puts_P(PSTR("\r\nNeuer Name: "));
					for(i=0; i<sizeof(flower.name)-1; i++)
					{
						flower.name[i] = 0;
						z = uart_getchar();	
						if(z == '\r' || z == '\n')
							break;
						flower.name[i] = z;
						printf("%c", z);
					}
					flower.name[sizeof(flower.name)-1] = 0;
					if(i==0) break;
					save = 1;
					break;					
					
				case 't':
					uart_puts_P(PSTR("\r\nGiessintervall in Stunden ?"));
					flower.hours_off = uart_read_nr();			
					uart_puts_P(PSTR("\r\nGiesszeit in Sekunden ?"));
					flower.seconds_on = uart_read_nr();
					save = 1;
					break;
					
				default:
					return uart_in;
			}
			if(save)
			{
				eeprom_write_block(&flower, &gpEEPROM[index], sizeof(struct eeprom_giess));
				print_flower_setup(index, &flower);
			}
		}
	}
}

int main (void)
{
	unsigned char i;
	char uart_in;
	unsigned char sec = 0;

	ADCSRA = (1<<ADEN) | 0x04;
	PORTD = 0x04;
	DDRB = 0x01;
	DDRD = 0xFC;
	PORTB = 0;
	
	zeit.day = 1;
	zeit.month = 1;
	tickcount = eeprom_read_word(EEPROM_ADDR_TICKCOUNT);
	if(tickcount == 0 || tickcount == 0xFFFF)
		tickcount = (SYSCLK/256 - 1);
	Timer1_Init();
	UART_Init();
	sei();
	
	for(i=0; i<6; i++)
		memcpy(&zuletzt_gegossen[i], &zeit, sizeof(struct time_st));
		
	print_menu();
		
	while(1) 
	{
		if(sec != zeit.sec)
		{
			uart_puts_P(PSTR("\r"));
			print_time(&zeit);
			sec = zeit.sec;
			autogiess();
		}
		if(uart_is_rx())
		{
			uart_in = uart_getchar();
			while(uart_in >= '1' && uart_in <= '6')
				uart_in = flower_setup(uart_in - '1');
				
			if(uart_in == 'a')
				print_adcs();
								
			if(uart_in == 'k')
				print_config();
				
			if(uart_in == 'u')
				set_time();		
					
			print_menu();	
		}
	}
	
	return 1;
}

uint16_t read_adc(char port)
{
	ADMUX = port;
	ADCSRA |= (1<<ADSC);
	while(ADCSRA & (1<<ADSC));
	return ADCW;
}

void autogiess()
{
	unsigned char i;
	uint16_t feuchte;
	struct eeprom_giess giess;
	char pump_running;
	
	for(i=0; i<6; i++)
	{
		eeprom_read_block(&giess, &gpEEPROM[i], sizeof(struct eeprom_giess));
		pump_running = pump_status(i);
		feuchte = read_adc(i);
		
		if(giess.automatik == AUTOMATIK_MEAS)
		{
			if(feuchte == 1023 || feuchte == 0 || giess.pump_on <= giess.pump_off)
			{
				if(pump_running)
					switch_pump(i, 0);
				continue;
			}
				
			if(pump_running)
			{
				if(feuchte < giess.pump_off)
				{
					switch_pump(i, 0);
				}
			} else 
			{
				if(feuchte > giess.pump_on)
				{
					switch_pump(i, 1);
				}
			}
		}
				
		if(giess.automatik == AUTOMATIK_TIME)
		{
			if(pump_running)
			{
				if(zeit.sec_cnt - zuletzt_gegossen[i].sec_cnt >= giess.seconds_on)
				{
					switch_pump(i, 0);						
				}
			} else
			{
				if(zeit.hour_cnt - zuletzt_gegossen[i].hour_cnt >= giess.hours_off)
				{
					switch_pump(i, 1);
				}
			}
		}
		
		if(giess.automatik == AUTOMATIK_WARN)
		{
			if(feuchte == giess.pump_on)
			{
				if(pump_running)
					switch_pump(i, 0);
				else
					switch_pump(i, 1);
			} else
				switch_pump(i, 0);
		}
	}	
}


