#include "main.h"
volatile unsigned int CountMilliseconds = 0;

int seconds = 0;

SIGNAL (SIG_OVERFLOW0)
{
 TCNT0 -= 125;
 CountMilliseconds++;
 if(CountMilliseconds%1000 == 0)
 	seconds++;
}

enum {
  STOP             = 0,
  CK               = 1,
  CK8              = 2,
  CK64             = 3,
  CK256            = 4,
  CK1024           = 5,
  T0_FALLING_EDGE  = 6,
  T0_RISING_EDGE   = 7
};

void Timer0_Init(void)
{
// Timer/Counter 0 initialization
// (for system Clock = 8.000.000)
// Clock source: System Clock
// Mode: Normal top=FFh
// OC0 output: Disconnected
 TCCR0 = CK64;
 TCNT0 = -125;  // reload
// OCR0  = 0x00;
// Timer(s)/Counter(s) Interrupt(s) initialization
 TIMSK |= 0x01;
}


unsigned int SetDelay (unsigned int t)
{
  return(CountMilliseconds + t);                                             
}

char CheckDelay (unsigned int t)
{
  return(((t - CountMilliseconds) & 0x8000) >> 8);
}

void Delay_ms(unsigned int w)
{
 unsigned int akt;
 akt = SetDelay(w);
 while (!CheckDelay(akt));
}
